Extension { #name : #PRLineBreak }

{ #category : #'*Grafoscopio' }
PRLineBreak >> formattedText [
	^ OSPlatform current lineEnding
]

{ #category : #'*Grafoscopio' }
PRLineBreak >> isLineBreak [
	^ true
]

{ #category : #'*Grafoscopio' }
PRLineBreak >> isTextOrLineBreak [
	^ true
]

{ #category : #'*Grafoscopio' }
PRLineBreak >> leftFormatSize [
	^ self formats
		inject: 0
		into: [ :acc :f | acc + f leftSize ]
]

{ #category : #'*Grafoscopio' }
PRLineBreak >> next [
	^ self propertyAt: #next ifAbsent: [ nil ]
]

{ #category : #'*Grafoscopio' }
PRLineBreak >> next: aText [ 
	self propertyAt: #next put: aText
]

{ #category : #'*Grafoscopio' }
PRLineBreak >> rightFormatSize [
	^ self formats
		inject: 0
		into: [ :acc :f | acc + f rightSize ]
]

{ #category : #'*Grafoscopio' }
PRLineBreak >> text [
	^ OSPlatform current lineEnding
]

{ #category : #'*Grafoscopio' }
PRLineBreak >> text: aString [ 
	self shouldBeImplemented.
]

{ #category : #'*Grafoscopio' }
PRLineBreak >> textSize [
	^ self text size
]

{ #category : #'*Grafoscopio' }
PRLineBreak >> textStart: aValue [
	^ self
		propertyAt: #textStart
		put: aValue
]

{ #category : #'*Grafoscopio' }
PRLineBreak >> textStop: aValue [
	^ self
		propertyAt: #textStop
		put: aValue
]
